<?php
class secret_http
{
	protected $last_error = '';
	protected $keys = array('origin' => '', 'access_key' => '', 'secret_key' => '');

	public function __construct($data)
	{
		if($data) $this->setkey($data);
	}
	
	public function lastError() 
	{
		return $this->last_error;
	}
	
	public function setError($err) 
	{
		return $this->last_error = $err;
	}
	
	public function ClassName()
	{
		return get_class($this);
	}
	
	public function setkey($data)
	{
		foreach($this->keys as $key => $val) {
			if(isset($data[$key])) 
				$this->keys[$key] = $data[$key];
		}
	}

	public function getkey($key)
	{
		if(isset($this->keys[$key]))
			return $this->keys[$key];
		return NULL;
	}

	public function request($pathname, $str_params, $str_data)
	{
		list($usec, $sec) = explode(" ", microtime());
		$tonce = $sec . str_pad(substr($usec, 2, 6), 6, '0', STR_PAD_RIGHT);

		$data = '';
		if($str_data !== NULL && isset($str_data)) {
			$method = 'POST';
			if($str_data != '') $data = MD5($str_data);
		}
		else
			$method = 'GET';

		$signature = "{$method}|{$pathname}|{$tonce}|{$this->keys['access_key']}|{$str_params}|{$data}";
		$hash = hash_hmac('sha256', $signature, $this->keys['secret_key']);
		$Authorization =  base64_encode("{$this->keys['access_key']}:{$hash}");

		$headarray = array(
			"Authorization: Basic {$Authorization}",
			"Json-Rpc-Tonce: {$tonce}",
			"Content-type: application/json; charset=utf-8",
			"Accept: */*"
		);

		var_dump($signature, $headarray, $str_data);
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, "{$this->keys['origin']}{$pathname}");
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER,FALSE);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST,FALSE);
		curl_setopt($curl, CURLOPT_SSLVERSION, 1);

		var_dump($curl);
		// 允许执行的最长秒数。
		curl_setopt($curl, CURLOPT_TIMEOUT, 8); 
		// 在发起连接前等待的时间，如果设置为0，则无限等待。
		// curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 30); 
		// 在内存中保存DNS信息的时间，默认为120秒。
		// curl_setopt($curl, CURLOPT_DNS_CACHE_TIMEOUT, 120);

		if($method == 'POST') {
			curl_setopt($curl, CURLOPT_POST, 1); 
			curl_setopt($curl, CURLOPT_POSTFIELDS, $str_data);
		}
		curl_setopt($curl,CURLOPT_HTTPHEADER, $headarray);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		
		$output = curl_exec($curl);
		$error = curl_error($curl);
		$response_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		curl_close($curl);
		
		$response = array(
			'code' => $response_code,
			'err' => $error,
			'data' => $output,
		);
		//var_dump($curl, "{$this->keys['origin']}{$pathname}", $response);
		return $response;
	}
}

class yundisms extends secret_http
{
	public function __construct()
	{
		$this->keys = array(
			// 'origin' => 'https://106.37.74.77:60043', 
			'origin' => 'https://49.7.226.189:60043',
			'access_key' => '3b04e7bf-dcff-4c59-b655-84e9332aba95', 
			'secret_key' => '563fbeaa-1c26-4a83-bb66-db59b90e7a27'
		);
	}

	public function request($pathname, $str_params, $str_data)
	{
		$ret = parent::request($pathname, $str_params, $str_data);

		if ($ret['code'] >= 400) {
			$this->setError(__METHOD__ . ": fail, code={$ret['code']} url={$this->origin}{$path} err=\"{$ret['err']}\" body={$ret['data']}");
			return false;
		}

		$data = json_decode($ret['data'], true);
		if(!$data) {
			$this->setError(__METHOD__ . ": json_decode fail, http code={$ret['code']} url={$origin}{$path} body={$ret['data']}");
			return false;
		}

		return $data;
	}
	
	public function smsSend($data)
	{
		// 必需：否，短信消息备注
		//if(isset($data['smsComment']))
		//	$smsComment = time($data['smsComment']);
		//else
		//	$smsComment = '';

		// 必需：是，短信接收人 
		// 必需：否，接收人名字
		if(isset($data['recvName']))
			$recvName = time($data['recvName']);
		else
			$recvName = '';

		// 必需：是，接收人手机
		if(!isset($data['recvPhone'])
		|| ($recvPhone = trim($data['recvPhone'])) == '') {
			set_errmsg(MSG_LEVEL_ARG, __function__, "参数“recvPhone”不能为空。");
			return false;
		}
		
		// 必需：是，短信内容
		if(!isset($data['smsContent'])
		|| ($smsContent = trim($data['smsContent'])) == '') {
			set_errmsg(MSG_LEVEL_ARG, __function__, "参数“smsContent”不能为空。");
			return false;
		}

		$smsdata = array(
			'businessCode' => 'panabit',
			'messageId' => '', 						// 必需：否 模板id
			'smsGateway' => 1,
			'smsComment' => '云堤派网云平台短信验证码通道', // 必需：否 短信消息备注
			'smsRecvs' => array(
				array(
					'recvName'	=> $recvName,		// 必需：否 接收人名字
					'recvPhone'	=> $recvPhone,		// 必需：是 接收人手机
					'type' => 1						// 必需：是 收件人类型，0内部联系人，1客户联系人，2代
				)
			)
		);

		$smsdata['messageId'] = sms_uuid();
		$smsdata['smsContent'] = $smsContent;

		$strdata = json_encode($smsdata);

		return $this->request('/v1/open/smsSend', '', $strdata);
	}
}

function sms_uuid()
{
     // Generate 128 bit random sequence 
     $randmax_bits = strlen(base_convert(mt_getrandmax(), 10, 2));  // how many bits is mt_getrandmax()
     $x = '';
     while (strlen($x) < 128) {
         $maxbits = (128 - strlen($x) < $randmax_bits) ? 128 - strlen($x) :  $randmax_bits;
         $x .= str_pad(base_convert(mt_rand(0, pow(2,$maxbits)), 10, 2), $maxbits, "0", STR_PAD_LEFT);
     }

     // break into fields
     $a = array();
     $a['time_low_part'] = substr($x, 0, 32);
     $a['time_mid'] = substr($x, 32, 16);
     $a['time_hi_and_version'] = substr($x, 48, 16);
     $a['clock_seq'] = substr($x, 64, 16);
     $a['node_part'] =  substr($x, 80, 48);
     
     // Apply bit masks for "random or pseudo-random" version per RFC
     $a['time_hi_and_version'] = substr_replace($a['time_hi_and_version'], '0100', 0, 4);
     $a['clock_seq'] = substr_replace($a['clock_seq'], '10', 0, 2);

    // Format output
    return sprintf('%s-%s-%s%s%s',
        str_pad(base_convert($a['time_low_part'], 2, 16), 8, "0", STR_PAD_LEFT),
        str_pad(base_convert($a['time_mid'], 2, 16), 4, "0", STR_PAD_LEFT),
        str_pad(base_convert($a['time_hi_and_version'], 2, 16), 4, "0", STR_PAD_LEFT),
        str_pad(base_convert($a['clock_seq'], 2, 16), 4, "0", STR_PAD_LEFT),
        str_pad(base_convert($a['node_part'], 2, 16), 12, "0", STR_PAD_LEFT));

}



?>